--[[
script version 1.2
this pricing script is designed for individuals to create or collect there own pricing information in whatever means they so choose and import that information into the magic album application.
to do so create the file "cardprices.txt" in the root folder of the magic album application.  inside the file each line represents a card and its associated information.  the expected line format is as follows:
(cardname{tab}cardprice{tab}setname{tab}cardlanguage{tab}cardversion{tab}foil/nonfoil)
valid complete example line:
Abuna Acolyte	0.24	Scars of Mirrodin	English	*	nonfoil
Abuna Acolyte	0.24	Scars of Mirrodin	English	0	nonfoil

valid part-complete example line:
Abuna Acolyte	0.24	Scars of Mirrodin			

invalid line examples:
Abuna Acolyte	0.24	SOM	eng	0	nonfoil
Abuna Acolyte	0.24	Scars of Mirrodin	english	0	nonfoil
Abuna Acolyte	0.24		eng	0	nonfoil

requirements:
setname must match setnames defined in "tab" table (see below)
cardlanguage must match a language  defined in the suplang table (see below)
price values must not contain commas
you must define a card name
you must define a card price
you must define a card set nam
all other values if not present will use default values listed below

defaults:
cardlanguage will default to english (eng)
cardversion will default to * (all versions)
cardfoiling will default ot nonfoil

variable / table descriptions:
dbg		debug			"on" turns debuging on, "off" turns debuging off
cpf		card price file	file (including path if not local) to the file containing the card pricing information
id		id			setid used in the magic album application
setname	setname		name of set associated with id
--]]

tab ={
	{id = 781, setname = "Duel Decks: Ajani vs. Nicol Bolas"},
	{id = 780, setname = "From the Vault: Legends"},
	{id = 779, setname = "Magic 2012"},
	{id = 778, setname = "Magic: The Gathering Commander"},
	{id = 778, setname = "Magic: The Gathering Commander Oversized"},
	{id = 777, setname = "Duel Decks: Knights vs. Dragons"},
	{id = 776, setname = "New Phyrexia"},
	{id = 775, setname = "Mirrodin Besieged"},
	{id = 774, setname = "Premium Deck Series: Fire & Lightning"},
	{id = 773, setname = "Scars of Mirrodin"},
	{id = 772, setname = "Duel Decks: Elspeth vs. Tezzeret"},
	{id = 771, setname = "From the Vault: Relics"},
	{id = 770, setname = "Magic 2011"},
	{id = 769, setname = "Archenemy"},
	{id = 768, setname = "Duels of the Planeswalkers"},
	{id = 767, setname = "Rise of the Eldrazi"},
	{id = 766, setname = "Duel Decks: Phyrexia vs. The Coalition"},
	{id = 765, setname = "WorldWake"},
	{id = 764, setname = "Premium Deck Series: Slivers"},
	{id = 763, setname = "Duel Decks: Garruk vs. Liliana"},
	{id = 762, setname = "Zendikar"},
	{id = 761, setname = "Planechase"},
	{id = 760, setname = "From the Vault: Exiled"},
	{id = 759, setname = "Magic 2010"},
	{id = 758, setname = "Alara Reborn"},
	{id = 757, setname = "Duel Decks: Divine vs. Demonic"},
	{id = 756, setname = "Conflux"},
	{id = 755, setname = "Duel Decks: Jace vs. Chandra"},
	{id = 754, setname = "Shards of Alara"},
	{id = 753, setname = "From the Vault: Dragons"},
	{id = 752, setname = "Eventide"},
	{id = 751, setname = "Shadowmoor"},
	{id = 750, setname = "Morningtide"},
	{id = 740, setname = "Duel Decks: Elves vs. Goblins"},
	{id = 730, setname = "Lorwyn"},
	{id = 720, setname = "Tenth Edition"},
	{id = 710, setname = "Future Sight"},
	{id = 700, setname = "Planar Chaos"},
	{id = 690, setname = "Time Spiral Timeshifted"},
	{id = 680, setname = "Time Spiral"},
	{id = 675, setname = "Coldsnap Them Decks"},
	{id = 670, setname = "Coldsnap"},
	{id = 660, setname = "Dissension"},
	{id = 650, setname = "Guildpact"},
	{id = 640, setname = "Ravnica: City of Guilds"},
	{id = 635, setname = "Magic Encyclopedia"},
	{id = 630, setname = "9th Edition"},
	{id = 620, setname = "Saviors of Kamigawa"},
	{id = 610, setname = "Betrayers of Kamigawa"},
	{id = 600, setname = "Unhinged"},
	{id = 590, setname = "Champions of Kamigawa"},
	{id = 580, setname = "Fifth Dawn"},
	{id = 570, setname = "Darksteel"},
	{id = 560, setname = "Mirrodin"},
	{id = 550, setname = "8th Edition"},
	{id = 540, setname = "Scourge"},
	{id = 530, setname = "Legions"},
	{id = 520, setname = "Onslaught"},
	{id = 510, setname = "Judgment"},
	{id = 500, setname = "Torment"},
	{id = 490, setname = "Deckmasters"},
	{id = 480, setname = "Odyssey"},
	{id = 470, setname = "Apocalypse"},
	{id = 460, setname = "7th Edition"},
	{id = 450, setname = "Planeshift"},
	{id = 440, setname = "Beatdown"},
	{id = 430, setname = "Invasion"},
	{id = 420, setname = "Prophecy"},
	{id = 415, setname = "Starter 2000"},
	{id = 410, setname = "Nemesis"},
	{id = 405, setname = "Battle Royale"},
	{id = 400, setname = "Mercadian Masques"},
	{id = 390, setname = "Starter 1999"},
	{id = 380, setname = "Portal Three Kingdoms"},
	{id = 370, setname = "Urza's Destiny"},
	{id = 360, setname = "6th Edition"},
	{id = 350, setname = "Urza's Legacy"},
	{id = 340, setname = "Anthologies"},
	{id = 330, setname = "Urza's Saga"},
	{id = 320, setname = "Unglued"},
	{id = 310, setname = "Portal Second Age"},
	{id = 300, setname = "Exodus"},
	{id = 290, setname = "Stronghold"},
	{id = 280, setname = "Tempest"},
	{id = 270, setname = "Weatherlight"},
	{id = 260, setname = "Portal"},
	{id = 250, setname = "5th Edition"},
	{id = 240, setname = "Visions"},
	{id = 230, setname = "Mirage"},
	{id = 225, setname = "Introductory Two-Player Set"},
	{id = 220, setname = "Alliances"},
	{id = 210, setname = "Homelands"},
	{id = 200, setname = "Chronicles"},
	{id = 190, setname = "Ice Age"},
	{id = 180, setname = "4th Edition"},
	{id = 170, setname = "Fallen Empires"},
	{id = 160, setname = "The Dark"},
	{id = 150, setname = "Legends"},
	{id = 140, setname = "Revised"},
	{id = 130, setname = "Antiquities"},
	{id = 120, setname = "Arabian Nights"},
	{id = 110, setname = "Unlimited"},
	{id = 100, setname = "Beta"},
	{id = 90, setname = "Alpha"},
	{id = 70, setname = "Vanguard"},
	{id = 50, setname = "Full Box Promotion"},
	{id = 45, setname = "Magic Premiere Shop"},
	{id = 43, setname = "Two-Headed Giant Promos"},
	{id = 42, setname = "Summer of Magic Promos"},
	{id = 41, setname = "Happy Holidays Promos"},
	{id = 40, setname = "Arena League Promos"},
	{id = 33, setname = "World Championship Cards"},
	{id = 32, setname = "Pro Tour Promos"},
	{id = 31, setname = "Grand Prix Promos"},
	{id = 30, setname = "Friday Night Magic Promos"},
	{id = 27, setname = "Alternate Art Lands"},
	{id = 26, setname = "Magic Game Day"},
	{id = 25, setname = "Judge Gift Cards"},
	{id = 24, setname = "Champs Promos"},
	{id = 23, setname = "Gateway & WPN Promos"},
	{id = 22, setname = "Prerelease Promos"},
	{id = 21, setname = "Release & Launch Parties Promos"},
	{id = 20, setname = "Magic Player Rewards"},
	{id = 15, setname = "Convention Promos"},
	{id = 10, setname = "Junior Series Promos"},
	{id = 9, setname = "Video Game Promos"},
	{id = 8, setname = "Stores Promos"},
	{id = 7, setname = "Magazine Inserts"},
	{id = 6, setname = "Comic Inserts"},
	{id = 5, setname = "Book Inserts"},
	{id = 4, setname = "Richard Garfield Events"},
	{id = 2, setname = "DCI Legend Membership"},
	{id = 1, setname = "Other Promos"},
	}
	
suplang = {
	  {full = "English", abbr="ENG"},
	  {full = "Russian", abbr="RUS"},
	  {full = "German", abbr="GER"},
	  {full = "French", abbr="FRA"},
	  {full = "Italian", abbr="ITA"},
	  {full = "Portuguese", abbr="POR"},
	  {full = "Spanish", abbr="SPA"},
	  {full = "Japanese", abbr="JPN"},
	  {full = "Simplified Chinese", abbr="ZHC"},
	  {full = "Traditional Chinese", abbr="ZHT"},
	  {full = "Korean", abbr="KOR"},
	  {full = "Hebrew", abbr="HEB"},
	  {full = "Arabic", abbr="ARA"},
	  {full = "Latin", abbr="LAT"},
	  {full = "Sanskrit", abbr="SAN"},
	  {full = "Ancient Greek", abbr="GRC"},
}
	
function explode(d,p)
	local t, ll
	t={}
	ll=0
	if(#p == 1) then return p end
	while true do
		l=string.find(p,d,ll+1,true)
		if l~=nil then
			table.insert(t, string.sub(p,ll,l-1))
			ll=l+1
		else
			table.insert(t, string.sub(p,ll))
			break
		end
	end
	return t
end
	
function trimspaces (s)
      return (string.gsub(s, "^%s*(.-)%s*$", "%1"))
end

ccount = 0
nfnum = 0
fnum = 0
cpf = "findmagiccards.txt"
dbg = "off"

function Start()

	openfile = io.open(cpf, "r")
	while true do
		--expected line format (cardname{tab}cardprice{tab}setname{tab}cardlanguage{tab}cardversion{tab}foil/nonfoil)
		line = openfile:read("*line")
		if not line then break end
		if dbg ~= "off" then ma.Log("currentline: [" .. line .. "]") end
		linesplit = explode("\t",line)
		lsc = 1
		cardname = nil
		cardcost = nil
		cardset = nil
		cardlanguage = nil
		cardversion = nil
		cardfoiling = nil
		cardsetid = nil
		cardabbr = nil
		els = 6
		cardlinevalid = "no"
		for i in ipairs(linesplit) do
			if lsc == 1 then cardname = trimspaces(linesplit[i]) end
			if lsc == 2 then cardcost = trimspaces(linesplit[i]) end
			if lsc == 3 then cardset = trimspaces(linesplit[i]) end
			if lsc == 4 then cardlanguage = linesplit[i] end
			if lsc == 5 then cardversion = linesplit[i] end
			if lsc == 6 then cardfoiling = linesplit[i] end
			if lsc > els then break end 
			lsc = lsc + 1
		end
		--identify card set id from setname
		for _,rec in ipairs(tab) do
			if cardset == rec.setname then
				cardsetid = rec.id
			end 
		end
		--identify card language abbr
		for _,rec in ipairs(suplang) do
			if cardlanguage == rec.full then
				cardabbr = rec.abbr
			end
		end
		
		--verify required fields are set before attempting to set card price
		if cardsetid ~= nil then
			if cardname ~= nil then
				if cardcost ~= nil then
					cardlinevalid = "yes"
					--define default values if values are not present
					if cardversion == "0" then cardversion = "" end
					if cardversion == "1" then cardversion = 1 end
					if cardversion == "2" then cardversion = 2 end
					if cardversion == "3" then cardversion = 3 end
					if cardversion == "4" then cardversion = 4 end
					if cardversion == nil then cardversion = "*" end
					if cardlanguage == nil then cardlanguage = "ENG" end
					if cardfoiling == nil then cardfoiling = "nonfoil" end
					--write debug information
					if dbg ~= "off" then ma.Log("[" .. cardname .. "],[" .. cardcost .. "],[" .. cardset .. "],[" .. cardsetid .. "],[" .. cardlanguage .. "],[" .. cardabbr .. "],[" .. cardversion .. "],[" .. cardfoiling .. "]") end
					if cardfoiling == "nonfoil" then
						--set nonfoil card price
						ma.SetPBar(cardname,100*nfnum/ccount)
						ma.SetPrice(cardsetid,cardabbr,cardname,cardversion,cardcost,0)
						nfnum = nfnum + 1
					end
					if cardfoiling == "foil" then
						--set foil card price
						ma.SetPBar(cardname,100*fnum/ccount)
						ma.SetPrice(cardsetid,cardabbr,cardname,cardversion,0,cardcost)
						fnum = fnum + 1
					end
				end
			end
		end
		if cardlinevalid == "no" then
			ma.Log("[WARNING]\tInvalidPriceLine: (" .. line .. ")")
		end
	end
	ma.Log(nfnum .. " total non-foil card price(s) set")
	ma.Log(fnum .. " total foil card price(s) set")
end